/**
 * Copyright (C) 1998-2012 enStratus Networks Inc
 *
 * ====================================================================
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ====================================================================
 */

package org.dasein.util.uom.time;

import javax.annotation.Nonnull;
import java.text.ChoiceFormat;
import java.text.MessageFormat;

public class Day extends TimePeriodUnit {
    static public TimePeriod<Day> valueOf(short days) {
        return new TimePeriod<Day>(days, TimePeriod.DAY);
    }

    static public TimePeriod<Day> valueOf(int days) {
        return new TimePeriod<Day>(days, TimePeriod.DAY);
    }

    static public TimePeriod<Day> valueOf(long days) {
        return new TimePeriod<Day>(days, TimePeriod.DAY);
    }

    static public TimePeriod<Day> valueOf(double days) {
        return new TimePeriod<Day>(days, TimePeriod.DAY);
    }

    static public TimePeriod<Day> valueOf(float days) {
        return new TimePeriod<Day>(days, TimePeriod.DAY);
    }

    static public TimePeriod<Day> valueOf(Number days) {
        return new TimePeriod<Day>(days, TimePeriod.DAY);
    }
    
    public Day() { }
    
    public double getBaseUnitConversion() {
        return 24.0;
    }
    
    @Override
    public @Nonnull String format(@Nonnull Number quantity) {
        MessageFormat fmt = new MessageFormat("{0}");

        fmt.setFormatByArgumentIndex(0, new ChoiceFormat(new double[] {0,1,2}, new String[] {"0 days","1 day","{0,number} days"}));
        return fmt.format(new Object[] { quantity });
    }
}
